subroutine kernel_B222 (kernel, q, p, phi, k1, k2, k3)
  implicit none
  real*8, intent(in)   :: q, p, phi, k1, k2, k3
  real*8, intent(out)  :: kernel
  real*8 :: pi, cos_phi
  parameter (pi=3.141592653589793238462643383279502884197d0)

  cos_phi = cos(phi)

  kernel = (10.d0/7d0 + (5*(-q**2 + (k1**2 - p**2 + q**2)/2.))/(7.*p**2) + (5*(-q**2 + (k1**2 - p**2 + q**2)/2.))/(7.*q**2) + (2*k1**2*(-q**2 + (k1**2 - p**2 + q**2)/2.))/(7.*p**2*q**2))* &
       (10.d0/7d0 + (5*(-q**2 - ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) +  &
                 Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(4.*k1**2)))/(7.*q**2) +  &
         (5*(-q**2 - ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) + Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/ &
               (4.*k1**2)))/(7.*(k2**2 + q**2 + ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) +  &
                 Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(2.*k1**2))) +  &
         (2*k2**2*(-q**2 - ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) + Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/ &
               (4.*k1**2)))/(7.*q**2*(k2**2 + q**2 + ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) +  &
                 Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(2.*k1**2))))* &
       (10.d0/7d0 + (5*((-k1**2 - k2**2 + k3**2)/2. - q**2 + (k1**2 - p**2 + q**2)/2. -  &
              ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) + Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(4.*k1**2)))/ &
          (7.*p**2) + (5*((-k1**2 - k2**2 + k3**2)/2. - q**2 + (k1**2 - p**2 + q**2)/2. -  &
              ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) + Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(4.*k1**2)))/ &
          (7.*(k2**2 + q**2 + ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) + Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))* &
                  cos_phi)/(2.*k1**2))) + (2*k3**2*((-k1**2 - k2**2 + k3**2)/2. - q**2 + (k1**2 - p**2 + q**2)/2. -  &
              ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) + Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(4.*k1**2)))/ &
          (7.*p**2*(k2**2 + q**2 + ((-k1**2 - k2**2 + k3**2)*(k1**2 - p**2 + q**2) +  &
                 Sqrt((k1 + k2 - k3)*(k1 - k2 + k3)*(-k1 + k2 + k3)*(k1 + k2 + k3))*Sqrt((k1 + p - q)*(k1 - p + q)*(-k1 + p + q)*(k1 + p + q))*cos_phi)/(2.*k1**2)))) 
  return
end subroutine kernel_B222

subroutine kernel_B321_I (kernel, q, p, k3, k1, k2)
  implicit none
  real*8, intent(in)   :: q, p, k1, k2, k3
  real*8, intent(out)  :: kernel
  real*8 :: pi
  parameter (pi=3.141592653589793238462643383279502884197d0)
 
  kernel = ((2*k1**4 - 5*(p**2 - q**2)**2 + 3*k1**2*(p**2 + q**2))*(-14*k1**10 - 21*k1**8*(2*k3**2 + 5*(p**2 + q**2)) - 3*(k2**2 - k3**2)**2*(p**2 - q**2)**2*(28*k2**2 + 10*k3**2 + 7*(p**2 + q**2)) +  &
           2*k1**6*(-7*k2**4 + 23*k3**4 + 56*(p**2 - q**2)**2 + 53*k3**2*(p**2 + q**2) + k2**2*(68*k3**2 + 161*(p**2 + q**2))) -  &
           8*k1**5*(2*k3**4 + 5*k3**2*p**2 - 7*p**4)*(k2**2 - q**2)**2*Sqrt(1/ &
              (k2**4*p**2 + k1**2*(k3**2 - p**2)*(k2**2 - q**2) + k3**2*q**2*(k3**2 - p**2 + q**2) - k2**2*(-p**4 + p**2*q**2 + k3**2*(p**2 + q**2)))) -  &
           8*k1**5*(k2**2 - p**2)**2*(2*k3**4 + 5*k3**2*q**2 - 7*q**4)*Sqrt(1/ &
              (k2**4*q**2 + k1**2*(k2**2 - p**2)*(k3**2 - q**2) + k3**2*p**2*(k3**2 + p**2 - q**2) - k2**2*(q**2*(p**2 - q**2) + k3**2*(p**2 + q**2)))) +  &
           k1**4*(28*k2**6 + 10*k3**6 - 5*k3**4*(p**2 + q**2) - 2*k3**2*(31*p**4 - 74*p**2*q**2 + 31*q**4) + 7*(p**6 - 9*p**4*q**2 - 9*p**2*q**4 + q**6) - k2**4*(30*k3**2 + 329*(p**2 + q**2)) +  &
              k2**2*(24*k3**4 + 22*k3**2*(p**2 + q**2) - 56*(7*p**4 - 17*p**2*q**2 + 7*q**4))) +  &
           2*k1**2*(28*k2**6*(p**2 + q**2) + 10*k3**6*(p**2 + q**2) + 7*k3**2*(p**2 - q**2)**2*(p**2 + q**2) - 2*k3**4*(5*p**4 - 24*p**2*q**2 + 5*q**4) -  &
              2*k2**4*(-91*p**4 + 168*p**2*q**2 - 91*q**4 + 23*k3**2*(p**2 + q**2)) + k2**2*(8*k3**4*(p**2 + q**2) + 7*(p**2 - q**2)**2*(p**2 + q**2) - 8*k3**2*(12*p**4 - 17*p**2*q**2 + 12*q**4)))))/(18816.*k1**4*k2**2*p**4*q**4)
  return
end subroutine kernel_B321_I

subroutine kernel_B321_II (kernel, q, k1, k2, k3)
  implicit none
  real*8, intent(in)   :: q, k1, k2, k3
  real*8, intent(out)  :: kernel
  real*8 :: pi
  parameter (pi=3.141592653589793238462643383279502884197d0)


  kernel = ((5*k1**4 + 5*k2**4 - 3*k2**2*k3**2 - 2*k3**4 - k1**2*(10*k2**2 + 3*k3**2))*pi* (4*k1*q*(-6*k1**6 + 79*k1**4*q**2 - 50*k1**2*q**4 + 21*q**6) + 3*(k1**2 - q**2)**3* (2*k1**2 + 7*q**2)*Log((k1 + q)**2/(k1 - q)**2)))/(7056.*k1**5*k2**2*q**5)

  return
end subroutine kernel_B321_II

subroutine kernel_B411_old (kernel, q, k1, k2, k3)
  implicit none
  real*8, intent(in)   :: q, k1, k2, k3
  real*8, intent(out)  :: kernel
  real*8 :: pi
  parameter (pi=3.141592653589793238462643383279502884197d0)

  kernel = (Pi*(4*k1*k2*k3*q*(585*k1**14*k2**6*k3**4 + 2475*k2**6*k3**4*(k2**2 - k3**2)**3*q**8 - 15*k1**2*k2**6*k3**4*(k2**2 - k3**2)*q**6*(1949*k2**4 + 20*k3**4 - 459*k3**2*q**2 + k2**2*(-1969*k3**2 + 855*q**2)) +  &
               15*k1**4*k2**6*k3**4*q**4*(3895*k2**6 + 606*k3**6 + 444*k3**4*q**2 + 405*k3**2*q**4 + k2**4*(-7096*k3**2 + 8694*q**2) + k2**2*(2595*k3**4 - 6566*k3**2*q**2 + 471*q**4)) -  &
               15*k1**12*(90*k2**8*k3**4 - 3895*k2**4*k3**4*q**4 + 1949*k2**2*k3**4*q**6 - 165*k3**4*q**8 + k2**6*(805*k3**6 + 1822*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6)) +  &
               k1**6*(585*k2**14*k3**4 - 2475*k3**10*q**8 + 15*k2**2*k3**8*q**6*(20*k3**2 - 459*q**2) + 45*k2**4*k3**6*q**4*(202*k3**4 + 148*k3**2*q**2 + 135*q**4) -  &
                  15*k2**12*(805*k3**6 + 1822*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6) + k2**10*(5655*k3**8 + 222610*k3**6*q**2 - 419226*k3**4*q**4 + 54180*k3**2*q**6 - 11340*q**8) +  &
                  2*k2**6*k3**4*(210*k3**8 - 34455*k3**6*q**2 + 4766*k3**4*q**4 - 28605*k3**2*q**6 + 5175*q**8) + &
               k2**8*k3**2*(5415*k3**8 - 120370*k3**6*q**2 + 250234*k3**4*q**4 - 148950*k3**2*q**6 + 7560*q**8)) + k1**10*(1530*k2**10*k3**4 - 7425*k3**6*q**8 + 15*k2**8*(1501*k3**6 + 1318*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6) - 30*k2**4*(3548*k3**6*q**4 - 4347*k3**4*q**6) +  &
                  k2**6*(5655*k3**8 + 222610*k3**6*q**2 - 419226*k3**4*q**4 + 54180*k3**2*q**6 - 11340*q**8) + 45*k2**2*(1306*k3**6*q**6 - 285*k3**4*q**8)) +  &
               k1**8*(-1350*k2**12*k3**4 + 7425*k3**8*q**8 + 15*k2**10*(1501*k3**6 + 1318*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6) +  &
                  k2**6*k3**2*(5415*k3**8 - 120370*k3**6*q**2 + 250234*k3**4*q**4 - 148950*k3**2*q**6 + 7560*q**8) + 2*k2**8*(7050*k3**8 - 227830*k3**6*q**2 + 370461*k3**4*q**4 - 50400*k3**2*q**6 + 11340*q**8) +  &
                  15*k2**4*(2595*k3**8*q**4 - 6566*k3**6*q**6 + 471*k3**4*q**8) - 135*k2**2*(221*k3**8*q**6 - 146*k3**6*q**8))) -  &
            15*k2**7*k3**5*(k1**2 - q**2)**2*(39*k1**12 + 165*(k2**2 - k3**2)**3*q**6 - k1**10*(582*k2**2 + 791*k3**2 + 1947*q**2) +  &
               k1**8*(51*k2**4 + 601*k3**4 + 1787*k3**2*q**2 + 1689*q**4 + k2**2*(2120*k3**2 + 6891*q**2)) -  &
               3*k1**2*(k2**2 - k3**2)*q**4*(558*k2**4 + k2**2*(-473*k3**2 + 285*q**2) - 17*(5*k3**4 + 9*k3**2*q**2)) +  &
               k1**6*(492*k2**6 + 151*k3**6 + 179*k3**4*q**2 - 1113*k3**2*q**4 + 219*q**6 - 3*k2**4*(211*k3**2 + 2155*q**2) + k2**2*(390*k3**4 + 758*k3**2*q**2 - 7284*q**4)) +  &
               k1**4*q**2*(1017*k2**6 + 269*k3**6 - 321*k3**4*q**2 + 405*k3**2*q**4 + k2**4*(-1677*k3**2 + 7269*q**2) + k2**2*(391*k3**4 - 4376*k3**2*q**2 + 471*q**4)))*Log((k1 + q)**2/(k1 - q)**2) -  &
            15*k1**7*k3**5*(k2**2 - q**2)**2*(39*k2**12 - 165*k3**6*q**6 - k2**10*(791*k3**2 + 1947*q**2) + k2**8*(601*k3**4 + 1787*k3**2*q**2 + 1689*q**4) +  &
               3*k1**6*(164*k2**6 + 339*k2**4*q**2 - 558*k2**2*q**4 + 55*q**6) + k2**6*(151*k3**6 + 179*k3**4*q**2 - 1113*k3**2*q**4 + 219*q**6) + k2**4*(269*k3**6*q**2 - 321*k3**4*q**4 + 405*k3**2*q**6) -  &
               51*k2**2*(5*k3**6*q**4 + 9*k3**4*q**6) + 3*k1**4*(17*k2**8 - 165*k3**2*q**6 - k2**6*(211*k3**2 + 2155*q**2) + k2**4*(-559*k3**2*q**2 + 2423*q**4) + k2**2*(1031*k3**2*q**4 - 285*q**6)) +  &
               k1**2*(-582*k2**10 + 495*k3**4*q**6 + k2**8*(2120*k3**2 + 6891*q**2) + k2**6*(390*k3**4 + 758*k3**2*q**2 - 7284*q**4) + k2**4*(391*k3**4*q**2 - 4376*k3**2*q**4 + 471*q**6) -  &
                  6*k2**2*(194*k3**4*q**4 - 219*k3**2*q**6)))*Log((k2 + q)**2/(k2 - q)**2) +  &
            105*k1**7*k2**7*(2*k3**4 + 7*k3**2*q**2 - 9*q**4)*(k1**6*(k3**4 + 2*k3**2*q**2 - 3*q**4) + k2**6*(k3**4 + 2*k3**2*q**2 - 3*q**4) + 4*k2**4*(4*k3**6 - 14*k3**4*q**2 + 13*k3**2*q**4 - 3*q**6) -  &
               2*k3**4*(k3**6 + k3**2*q**4 - 2*q**6) + k2**2*(-15*k3**8 + 46*k3**6*q**2 - 47*k3**4*q**4 + 8*k3**2*q**6) +  &
               k1**2*(-15*k3**8 + 46*k3**6*q**2 - 47*k3**4*q**4 + 8*k3**2*q**6 + k2**4*(-9*k3**4 - 2*k3**2*q**2 + 3*q**4) - 8*k2**2*(4*k3**6 - 17*k3**4*q**2 + 12*k3**2*q**4 - 3*q**6)) +  &
               k1**4*(k2**2*(-9*k3**4 - 2*k3**2*q**2 + 3*q**4) + 4*(4*k3**6 - 14*k3**4*q**2 + 13*k3**2*q**4 - 3*q**6)))*Log((k3 + q)**2/(k3 - q)**2)))/(3.10464e6*k1**9*k2**9*k3**5*q**5) +  &
       (Pi*((-7*k1**4*(k2**2 - q**2)**2*(-2*k3**4 - 7*k3**2*q**2 + 9*q**4)*Log((4*k1**2*q**2 + 2*(k2**2 - q**2)*(k3**2 - q**2) + 4*Sqrt(k1**2*q**2*(k2**2*k3**2 + (k1**2 - k2**2 - k3**2)*q**2 + q**4)))**2/ &
                 (-4*k1**2*q**2 + 2*(k2**2 - q**2)*(-k3**2 + q**2) + 4*Sqrt(k1**2*q**2*(k2**2*k3**2 + (k1**2 - k2**2 - k3**2)*q**2 + q**4)))**2))/ &
             Sqrt(k1**2*q**2*(k2**2*(k3**2 - q**2) + q**2*(k1**2 - k3**2 + q**2))) +  &
            (36*k3**4*(k1**2 - q**2)**2*(k2**2 - q**2)**2*Log((4*k3**2*q**2 + 2*(k1**2 - q**2)*(k2**2 - q**2) + 4*Sqrt(k3**2*q**2*(k1**2*k2**2 - (k1**2 + k2**2 - k3**2)*q**2 + q**4)))**2/ &
                 (-4*k3**2*q**2 + 2*(k1**2 - q**2)*(-k2**2 + q**2) + 4*Sqrt(k3**2*q**2*(k1**2*k2**2 - (k1**2 + k2**2 - k3**2)*q**2 + q**4)))**2))/ &
             Sqrt(k3**2*q**2*(k1**2*(k2**2 - q**2) + q**2*(-k2**2 + k3**2 + q**2))) -  &
            (7*k2**4*(k1**2 - q**2)**2*(-2*k3**4 - 7*k3**2*q**2 + 9*q**4)*Log((4*k2**2*q**2 + 2*(k1**2 - q**2)*(k3**2 - q**2) + 4*Sqrt(k2**2*q**2*(k1**2*k3**2 - (k1**2 - k2**2 + k3**2)*q**2 + q**4)))**2/ &
                 (-4*k2**2*q**2 + 2*(k1**2 - q**2)*(-k3**2 + q**2) + 4*Sqrt(k2**2*q**2*(k1**2*k3**2 - (k1**2 - k2**2 + k3**2)*q**2 + q**4)))**2))/ &
             Sqrt(k2**2*q**2*(k1**2*(k3**2 - q**2) + q**2*(k2**2 - k3**2 + q**2)))))/(51744*k1**2*k2**2*q**4) 
  return

end subroutine kernel_B411_old

subroutine kernel_B411 (kernel, qq, kk1, kk2, kk3)
  use mpmodule
  implicit none
  integer ndp, nwds
  parameter (ndp = 50, nwds = int(ndp/mpdpw + 2))
  real *8, intent(in):: qq, kk1, kk2, kk3
  real *8 cc
  parameter (cc = 3.10464e6)
  type (mp_real) ::pi
  type (mp_real) :: q, k1, k2, k3, cnst1, ker
  real*8, intent(out)  :: kernel
  
  pi = mppi(nwds)
  q = mpreald(qq, nwds)
  k1 = mpreald(kk1, nwds)
  k2 = mpreald(kk2, nwds)
  k3 = mpreald(kk3, nwds)

  cnst1 = mpreal(cc, nwds)

  ker = (pi*(4*k1*k2*k3*q*(585*k1**14*k2**6*k3**4 + 2475*k2**6*k3**4*(k2**2 - k3**2)**3*q**8 - 15*k1**2*k2**6*k3**4*(k2**2 - k3**2)*q**6*(1949*k2**4 + 20*k3**4 - 459*k3**2*q**2 + k2**2*(-1969*k3**2 + 855*q**2)) +  &
               15*k1**4*k2**6*k3**4*q**4*(3895*k2**6 + 606*k3**6 + 444*k3**4*q**2 + 405*k3**2*q**4 + k2**4*(-7096*k3**2 + 8694*q**2) + k2**2*(2595*k3**4 - 6566*k3**2*q**2 + 471*q**4)) -  &
               15*k1**12*(90*k2**8*k3**4 - 3895*k2**4*k3**4*q**4 + 1949*k2**2*k3**4*q**6 - 165*k3**4*q**8 + k2**6*(805*k3**6 + 1822*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6)) +  &
               k1**6*(585*k2**14*k3**4 - 2475*k3**10*q**8 + 15*k2**2*k3**8*q**6*(20*k3**2 - 459*q**2) + 45*k2**4*k3**6*q**4*(202*k3**4 + 148*k3**2*q**2 + 135*q**4) -  &
                  15*k2**12*(805*k3**6 + 1822*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6) + k2**10*(5655*k3**8 + 222610*k3**6*q**2 - 419226*k3**4*q**4 + 54180*k3**2*q**6 - 11340*q**8) +  &
                  2*k2**6*k3**4*(210*k3**8 - 34455*k3**6*q**2 + 4766*k3**4*q**4 - 28605*k3**2*q**6 + 5175*q**8) + &
               k2**8*k3**2*(5415*k3**8 - 120370*k3**6*q**2 + 250234*k3**4*q**4 - 148950*k3**2*q**6 + 7560*q**8)) + k1**10*(1530*k2**10*k3**4 - 7425*k3**6*q**8 + 15*k2**8*(1501*k3**6 + 1318*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6) - 30*k2**4*(3548*k3**6*q**4 - 4347*k3**4*q**6) +  &
                  k2**6*(5655*k3**8 + 222610*k3**6*q**2 - 419226*k3**4*q**4 + 54180*k3**2*q**6 - 11340*q**8) + 45*k2**2*(1306*k3**6*q**6 - 285*k3**4*q**8)) +  &
               k1**8*(-1350*k2**12*k3**4 + 7425*k3**8*q**8 + 15*k2**10*(1501*k3**6 + 1318*k3**4*q**2 - 210*k3**2*q**4 + 189*q**6) +  &
                  k2**6*k3**2*(5415*k3**8 - 120370*k3**6*q**2 + 250234*k3**4*q**4 - 148950*k3**2*q**6 + 7560*q**8) + 2*k2**8*(7050*k3**8 - 227830*k3**6*q**2 + 370461*k3**4*q**4 - 50400*k3**2*q**6 + 11340*q**8) +  &
                  15*k2**4*(2595*k3**8*q**4 - 6566*k3**6*q**6 + 471*k3**4*q**8) - 135*k2**2*(221*k3**8*q**6 - 146*k3**6*q**8))) -  &
            15*k2**7*k3**5*(k1**2 - q**2)**2*(39*k1**12 + 165*(k2**2 - k3**2)**3*q**6 - k1**10*(582*k2**2 + 791*k3**2 + 1947*q**2) +  &
               k1**8*(51*k2**4 + 601*k3**4 + 1787*k3**2*q**2 + 1689*q**4 + k2**2*(2120*k3**2 + 6891*q**2)) -  &
               3*k1**2*(k2**2 - k3**2)*q**4*(558*k2**4 + k2**2*(-473*k3**2 + 285*q**2) - 17*(5*k3**4 + 9*k3**2*q**2)) +  &
               k1**6*(492*k2**6 + 151*k3**6 + 179*k3**4*q**2 - 1113*k3**2*q**4 + 219*q**6 - 3*k2**4*(211*k3**2 + 2155*q**2) + k2**2*(390*k3**4 + 758*k3**2*q**2 - 7284*q**4)) +  &
               k1**4*q**2*(1017*k2**6 + 269*k3**6 - 321*k3**4*q**2 + 405*k3**2*q**4 + k2**4*(-1677*k3**2 + 7269*q**2) + k2**2*(391*k3**4 - 4376*k3**2*q**2 + 471*q**4)))*Log((k1 + q)**2/(k1 - q)**2) -  &
            15*k1**7*k3**5*(k2**2 - q**2)**2*(39*k2**12 - 165*k3**6*q**6 - k2**10*(791*k3**2 + 1947*q**2) + k2**8*(601*k3**4 + 1787*k3**2*q**2 + 1689*q**4) +  &
               3*k1**6*(164*k2**6 + 339*k2**4*q**2 - 558*k2**2*q**4 + 55*q**6) + k2**6*(151*k3**6 + 179*k3**4*q**2 - 1113*k3**2*q**4 + 219*q**6) + k2**4*(269*k3**6*q**2 - 321*k3**4*q**4 + 405*k3**2*q**6) -  &
               51*k2**2*(5*k3**6*q**4 + 9*k3**4*q**6) + 3*k1**4*(17*k2**8 - 165*k3**2*q**6 - k2**6*(211*k3**2 + 2155*q**2) + k2**4*(-559*k3**2*q**2 + 2423*q**4) + k2**2*(1031*k3**2*q**4 - 285*q**6)) +  &
               k1**2*(-582*k2**10 + 495*k3**4*q**6 + k2**8*(2120*k3**2 + 6891*q**2) + k2**6*(390*k3**4 + 758*k3**2*q**2 - 7284*q**4) + k2**4*(391*k3**4*q**2 - 4376*k3**2*q**4 + 471*q**6) -  &
                  6*k2**2*(194*k3**4*q**4 - 219*k3**2*q**6)))*Log((k2 + q)**2/(k2 - q)**2) +  &
            105*k1**7*k2**7*(2*k3**4 + 7*k3**2*q**2 - 9*q**4)*(k1**6*(k3**4 + 2*k3**2*q**2 - 3*q**4) + k2**6*(k3**4 + 2*k3**2*q**2 - 3*q**4) + 4*k2**4*(4*k3**6 - 14*k3**4*q**2 + 13*k3**2*q**4 - 3*q**6) -  &
               2*k3**4*(k3**6 + k3**2*q**4 - 2*q**6) + k2**2*(-15*k3**8 + 46*k3**6*q**2 - 47*k3**4*q**4 + 8*k3**2*q**6) +  &
               k1**2*(-15*k3**8 + 46*k3**6*q**2 - 47*k3**4*q**4 + 8*k3**2*q**6 + k2**4*(-9*k3**4 - 2*k3**2*q**2 + 3*q**4) - 8*k2**2*(4*k3**6 - 17*k3**4*q**2 + 12*k3**2*q**4 - 3*q**6)) +  &
               k1**4*(k2**2*(-9*k3**4 - 2*k3**2*q**2 + 3*q**4) + 4*(4*k3**6 - 14*k3**4*q**2 + 13*k3**2*q**4 - 3*q**6)))*Log((k3 + &
           q)**2/(k3 - q)**2)))/(cnst1*k1**9*k2**9*k3**5*q**5) +  &
       (pi*((-7*k1**4*(k2**2 - q**2)**2*(-2*k3**4 - 7*k3**2*q**2 + 9*q**4)*Log((4*k1**2*q**2 + 2*(k2**2 - q**2)*(k3**2 - q**2) + 4*Sqrt(k1**2*q**2*(k2**2*k3**2 + (k1**2 - k2**2 - k3**2)*q**2 + q**4)))**2/ &
                 (-4*k1**2*q**2 + 2*(k2**2 - q**2)*(-k3**2 + q**2) + 4*Sqrt(k1**2*q**2*(k2**2*k3**2 + (k1**2 - k2**2 - k3**2)*q**2 + q**4)))**2))/ &
             Sqrt(k1**2*q**2*(k2**2*(k3**2 - q**2) + q**2*(k1**2 - k3**2 + q**2))) +  &
            (36*k3**4*(k1**2 - q**2)**2*(k2**2 - q**2)**2*Log((4*k3**2*q**2 + 2*(k1**2 - q**2)*(k2**2 - q**2) + 4*Sqrt(k3**2*q**2*(k1**2*k2**2 - (k1**2 + k2**2 - k3**2)*q**2 + q**4)))**2/ &
                 (-4*k3**2*q**2 + 2*(k1**2 - q**2)*(-k2**2 + q**2) + 4*Sqrt(k3**2*q**2*(k1**2*k2**2 - (k1**2 + k2**2 - k3**2)*q**2 + q**4)))**2))/ &
             Sqrt(k3**2*q**2*(k1**2*(k2**2 - q**2) + q**2*(-k2**2 + k3**2 + q**2))) -  &
            (7*k2**4*(k1**2 - q**2)**2*(-2*k3**4 - 7*k3**2*q**2 + 9*q**4)*Log((4*k2**2*q**2 + 2*(k1**2 - q**2)*(k3**2 - q**2) + 4*Sqrt(k2**2*q**2*(k1**2*k3**2 - (k1**2 - k2**2 + k3**2)*q**2 + q**4)))**2/ &
                 (-4*k2**2*q**2 + 2*(k1**2 - q**2)*(-k3**2 + q**2) + 4*Sqrt(k2**2*q**2*(k1**2*k3**2 - (k1**2 - k2**2 + k3**2)*q**2 + q**4)))**2))/ &
             Sqrt(k2**2*q**2*(k1**2*(k3**2 - q**2) + q**2*(k2**2 - k3**2 + q**2)))))/(51744*k1**2*k2**2*q**4) 

  kernel = dble(ker)
  return 
end subroutine kernel_B411


